var dialog;
var namespacePrefix = {};
var namespaceUri = {};
var namespaceEnabled;
var namespaceIndex;
var acceptButton, cancelButton;
var returnFunction;

/*
function ValidatedField(aElement) {
    if (!aElement instanceof Components.interfaces.nsIDOMElement) {
        return null;
    }
    this.mElement = aElement;
}
ValidatedRegExp.prototype = {
    mElement: null,
    mReadOnly: false,

    init: function() {},
    validate: function() {
        return true;
    }
    get value() {
        return this.mElement.value;
    },
    set value(aValue) {
        this.mElement.value = aValue;
    },
}

function ValidatedTextField(aElement) {
    if (!aElement instanceof Components.interfaces.nsIDOMElement) {
        return null;
    }
    this.mElement = aElement;
    this.init();
}
ValidatedField.prototype = new ValidatedField();
ValidatedField.prototype.init = function() {
    this.mElement.addEventListener('input', this.validate, true);
}
ValidatedField.prototype.validate = function() {
    
}
*/

function onLoad() {
    dialog = document.documentElement;
    namespacePrefix.textbox = document.getElementById("namespacePrefix");
    namespacePrefix.broadcast = document.getElementById("bcastNamespacePrefix");
    namespaceUri.textbox = document.getElementById("namespaceUri");
    namespaceUri.broadcast = document.getElementById("bcastNamespaceUri");
    namespaceEnabled = document.getElementById("namespaceEnabled");

    namespaceIndex = window.arguments[0];
    namespacePrefix.textbox.value = window.arguments[1];
    namespaceUri.textbox.value = window.arguments[2];
    namespaceEnabled.checked = window.arguments[3];
    returnFunction = window.arguments[4];

    // Fetch the dialog buttons
    acceptButton = dialog.getButton('accept');
    cancelButton = dialog.getButton('cancel');

    /*
    var validatePrefix = new ValidateRegExp(namespacePrefix.textbox, /^[a-zA-Z0-9]+$/);
    */

    validatePrefix();
    validateURI();
}

function onAccept() {
    returnFunction(namespaceIndex, namespacePrefix.textbox.value, namespaceUri.textbox.value, namespaceEnabled.checked);
}

function validatePrefix(aEvent) {
    var value = namespacePrefix.textbox.value;
    if (value.match(/^[a-zA-Z0-9]+$/)) {
        namespacePrefix.valid = true;
        namespacePrefix.textbox.setAttribute('valid', 'true');
    } else {
        namespacePrefix.valid = false;
        namespacePrefix.textbox.setAttribute('valid', 'false');
    }
    updateValidatedGUI(aEvent);
}

function validateURI(aEvent) {
    var value = namespaceUri.textbox.value;
    if (value.match(/^[\w\d]+:.+$/)) {
        namespaceUri.textbox.setAttribute('valid', 'true');
        namespaceUri.valid = true;
    } else {
        namespaceUri.textbox.setAttribute('valid', 'false');
        namespaceUri.valid = false;
    }
    updateValidatedGUI(aEvent);
}

function updateValidatedGUI(aEvent) {
    if (namespaceUri.valid && namespacePrefix.valid) {
        acceptButton.setAttribute('disabled', 'false');
    } else {
        acceptButton.setAttribute('disabled', 'true');
    }
}
